﻿using Contracts.BindingModels;
using Contracts.ViewModels;
using DataModels.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DatabaseImplement.Models
{
	public class Performer : IPerformerModel
	{
		public int Id { get; private set; }

		[Required]
		public string NAME_PF { get; private set; } = string.Empty;

		[Required]
		public string login { get; private set; } = string.Empty;

		[Required]
		public string password { get; private set; } = string.Empty;

		[Required]
		public string SPECIALTY { get; private set; } = string.Empty;

		[Required]
		public int TeamId { get; set; }
		public virtual Team Team { get; set; }

		public static Performer? Create(PerformerBindingModel model)
		{
			if (model == null)
			{
				return null;
			}
			return new()
			{
				Id = model.Id,
				NAME_PF = model.NAME_PF,
				SPECIALTY = model.SPECIALTY,
				TeamId = model.TeamId,
				login = model.login,
				password = model.password
			};
		}

		public void Update(PerformerBindingModel model)
		{
			if (model == null)
			{
				return;
			}
			NAME_PF = model.NAME_PF;
			SPECIALTY = model.SPECIALTY;
			login = model.login;
			password = model.password;
		}

        public PerformerViewModel GetViewModel => new()
        {
            Id = Id,
            NAME_PF = NAME_PF,
            SPECIALTY = SPECIALTY,
            TeamId = TeamId,
            TeamName = Team.NAME_TM,
            login = login,
            password = password
        };
    }
}
