﻿using Contracts.BindingModels;
using Contracts.ViewModels;
using DataModels.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DatabaseImplement.Models
{
	public class Project : IProjectModel
	{
		public int Id { get; private set; }

		[Required]
		public string NAME_PJ { get; private set; } = string.Empty;

		[Required]
		public string DESCRIPTION_PJ { get; private set; } = string.Empty;

		[Required]
		public int TeamId { get; set; }
		public virtual Team Team { get; set; }

		public static Project? Create(ProjectBindingModel model)
		{
			if (model == null)
			{
				return null;
			}
			return new()
			{
				Id = model.Id,
				NAME_PJ = model.NAME_PJ,
				DESCRIPTION_PJ = model.DESCRIPTION_PJ,
				TeamId = model.TeamId,
			};
		}

		public void Update(ProjectBindingModel model)
		{
			if (model == null)
			{
				return;
			}
			NAME_PJ = model.NAME_PJ;
			DESCRIPTION_PJ = model.DESCRIPTION_PJ;
		}

		public ProjectViewModel GetViewModel => new()
		{
			Id = Id,
			NAME_PJ = NAME_PJ,
			DESCRIPTION_PJ = DESCRIPTION_PJ,
			TeamId = TeamId,
			TeamName = Team.NAME_TM
		};
	}
}
