﻿
using Contracts.BindingModels;
using Contracts.ViewModels;
using DataModels.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DatabaseImplement.Models
{
	public class TagGroup : ITagGroupModel
	{
		public int Id { get; private set; }

		[Required]
		public string NAME_TG { get; private set; } = string.Empty;

		[Required]
		public string COLOR { get; private set; } = string.Empty;

		public static TagGroup? Create(TagGroupBindingModel model)
		{
			if (model == null)
			{
				return null;
			}
			return new()
			{
				Id = model.Id,
				NAME_TG = model.NAME_TG,
				COLOR = model.COLOR,
			};
		}

		public void Update(TagGroupBindingModel model)
		{
			if (model == null)
			{
				return;
			}
			NAME_TG = model.NAME_TG;
			COLOR = model.COLOR;
		}

		public TagGroupViewModel GetViewModel => new()
		{
			Id = Id,
			NAME_TG = NAME_TG,
			COLOR = COLOR,
		};
	}
}
