﻿using Contracts.BindingModels;
using Contracts.ViewModels;
using DataModels.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DatabaseImplement.Models
{
	public class Team : ITeamModel
	{
		public int Id { get; private set; }

		[Required]
		public string NAME_TM { get; private set; } = string.Empty;

		[Required]
		public double RATING { get; private set; }

		public static Team? Create(TeamBindingModel model)
		{
			if (model == null)
			{
				return null;
			}
			return new()
			{
				Id = model.Id,
				NAME_TM = model.NAME_TM,
				RATING = model.RATING,
			};
		}

		public void Update(TeamBindingModel model)
		{
			if (model == null)
			{
				return;
			}
			NAME_TM = model.NAME_TM;
			RATING = model.RATING;
		}

		public TeamViewModel GetViewModel => new()
		{
			Id = Id,
			NAME_TM = NAME_TM,
			RATING = RATING,
		};
	}
}
