﻿using Microsoft.AspNetCore.Mvc;
using Contracts.BindingModels;
using Contracts.BusinessLogicContracts;
using Contracts.SearchModels;
using Contracts.ViewModels;

namespace TaskTrackerRestApi.Controllers
{
	[Route("api/[controller]/[action]")]
	[ApiController]
	public class ClientController : Controller
	{

		private readonly IPerformerLogic _logic;

		public ClientController(IPerformerLogic logic)
		{
			_logic = logic;
		}

		[HttpGet]
		public PerformerViewModel? Login(string login, string password)
		{
			try
			{
				return _logic.ReadElement(new PerformerSearchModel
				{
					login = login,
					password = password
				});
			}
			catch
			{
				throw;
			}
		}

		[HttpPost]
		public void Register(PerformerBindingModel model)
		{
			try
			{
				_logic.Create(model);
			}
			catch
			{
				throw;
			}
		}

		[HttpPost]
		public void UpdateData(PerformerBindingModel model)
		{
			try
			{
				_logic.Update(model);
			}
			catch
			{
				throw;
			}
		}
	}
}
